; Patch by Conn
; apply on Super Street fighter 2 - The New Challengers (U) with header

header
hirom



org $C00B8C    ; native hook to induce track change
JSL msuRoutine ; there is no free space in rom, these are ascii credits overwritten which are not used
NOP

org $C00E5A    ; mute spc in case new track s introduced
JSL pause



org $FFEC00
msuRoutine:
STA $1D75
LDY #$Fa
PHA
LDA $2002      ;check if msu found
CMP #$53               
BEQ msufound
PLA   
RTL            ; spc is played
msufound:
STZ $2006      ; mute old track
LDA $1D75
STA $2004   ; save track
STZ $2005
msuready:
Bit $2000
bvs msuready ; check if msu is ready
PHX
LDA $1D75
TAX
LDA $ffee00,x ;load loop value
sta $2007  
PLX
lda #$FF   ; volume
sta $2006
lda $2000
AND #$08
BNE playspc ; error bit set? 
PLA
LDY #$F9 ;mute SPC
RTL
playspc:
PLA
RTL



pause:
INY
STY $1D6b
PHA
LDA $2002      ;check if msu found
CMP #$53   
BEQ continue   
PLA
RTL            ; spc is played
continue:  ; mute track when in PAUSE modus
PLA
CMP #$F6    ; end of battle 
bne $06
stz $2007
stz $1D75
CMP #$01   ; prevent double spc play in menu/options
bne noend
LDA $1D75
CMP #$40
BNE noend2
lda $2000
AND #$08
BNE $04
lda #$F6
bra $02
noend2:
lda #$01
noend:
CMP #$FB   ; prevent double spc play in menu/options
bne $06
stz $2007
stz $1D75
CMP #$F0   ; mute start
bne $06
stz $2007
stz $1D75
CMP #$F3   ; pause start
bne $03
stz $2007
CMP #$F7    ; begin of battle
bne check
PHA
PHX
LDA $1D75
TAX
LDA $ffee00,x ;load loop value
STA $2007  ; also wenn ein theme endlos looped dann mach hier eine 03 auf 2007
PLX
PLA
check:
CMP #$F4   ; end pause
bne end
PHA
PHX
LDA $1D75
TAX
LDA $ffee00,x ;load loop value
STA $2007  ; also wenn ein theme endlos looped dann mach hier eine 03 auf 2007
PLX
PLA
end:
RTL



ORG $ffee00 ; loop table 03:loop, 01 non-loop
db $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03 ; themes 00-0f 
db $01,$01,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03 ; themes 10-1f
db $03,$03,$01,$03,$01,$01,$03,$01,$01,$01,$03,$01,$03,$01,$01,$01 ; themes 20-2f
db $01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01 ; themes 30-3f 
db $01,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03 ; themes 40-4f 
db $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03 ; themes 50-4f 
db $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03 ; themes 60-6f 
db $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03 ; themes 70-7f 
db $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03 ; themes 80-8f 	